
#include <cstdio>
#include <set>
#include <algorithm>
#include <queue>
using namespace std;

int main(void){
	int n,l,h,r;
	scanf("%d %d %d %d", &n, &l, &h, &r);
	vector<int> heights(n, -1);
	vector<vector<int> > data(n);
	for(int i=0;i<r;i++){
		int a,b;
		scanf("%d %d", &a, &b);
		if(a>b) swap(a,b);
		data[a-1].push_back(b-1);
	}
	for(int i=0;i<n;i++){
		sort(data[i].begin(), data[i].end());
		data[i].erase(unique(data[i].begin(), data[i].end()),data[i].end());
	}
	heights[0] = heights[n-1] = h;
	queue<pair<int,pair<int,int> > >q;
	q.push(make_pair(h, make_pair(0,n-1)));
	while(q.size()){
		int h    = q.front().first;
		int low  = q.front().second.first;
		int high = q.front().second.second;
		q.pop();
		while(low < high){
			if(heights[low]==-1)
				heights[low] = h;
			if(data[low].size()){
				int t = data[low].back();
				data[low].pop_back();
				q.push(make_pair(h-1, make_pair(low, t)));
				low = t;
			}else{
				low++;
			}
		}
	}
	for(int i=0;i<n;i++)
		printf("%d\n", heights[i]);
	return 0;
}
